ideal
p286
model tiny,pascal
codeseg
startupcode
false      =    0
true       =    1
k_ins      =    052h
intr       =    02Fh

begin:  jmp     setup

id      db      'ShareWare program ',??time
oldv    dd      ?
ecb1    dd      ?
ecb2    dd      ?
netaddr:
   addr db      127,0,0,1
   node db      0,0,0,0,0,10
   sock dw      ?
busy    db      false

proc    tsr     far
        cmp     [cs:busy],true
        je      @@1
        cmp     ax,7A00h
        jne     @@1
        mov     [cs:busy],true
        mov     al,0FFh
        lea     di,[cs:callback]
        push    cs
        pop     es
        mov     [cs:busy],false
        iret
@@1:
        jmp     [cs:oldv]
endp

proc    callback far
        push    cx si di es ds
        cmp     bx,0000h
        je      @opensocket
;        cmp     bx,0003h
;        je      @sendpacket
        cmp     bx,0004h
        je      @listenforpacket
        cmp     bx,0009h
        je      @getinternetworkaddr
        jmp     @exit
@opensocket:
        mov     [cs:sock],dx
        jmp     @exit
@listenforpacket:
        mov     [es:si],cx
        mov     [es:si+2],ax
        lea     di,[si+20]
        mov     [byte es:si+8],0FEh
        mov     [word cs:ecb2],si
        mov     [word cs:ecb2+2],es
        jmp     @exit
@getinternetworkaddr:
        push    ds
        pop     es
        mov     di,si
        push    cs
        pop     ds
        lea     si,[cs:netaddr]
        mov     cx,12
        cld
        rep     movsb
        jmp     @exit
@sendpacket:
;        mov     [word cs:ecb1],si
;        mov     [word cs:ecb1+2],es
;        jmp     @exit;----
 ;       lds     si,[cs:ecb1]          ;ds:si send    ECB
 ;       les     di,[cs:ecb2]          ;es:di receive ECB
;        cmp     [byte di+8],0FEh
;        jne     @exit
;        mov     [byte di+8],0
;        call    copybuf pascal, [es:di+40], [ds:si+36], [ds:si+38], [es:di+36], [es:di+38]
;        mov     bx,[es:di+36]
;        add     bx,17
;        mov     dx,[es:di+38]
 ;;       lea     cx,[netaddr]
 ;       call    copybuf pascal, 12, cx, cs, bx, dx
 ;       cmp     [word es:di+36], 2
 ;       jl      @exit
 ;       add     si,6
 ;       add     di,6
 ;       call    copybuf pascal, [es:di+40], [ds:si+36], [ds:si+38], [es:di+36], [es:di+38]
 ;       jmp     @exit
@exit:
        pop     ds es di si cx
        xor     ax,ax
        retf
endp

;proc    copybuf near
;        arg     coutn,_si,_ds,_di,_es: word
;        uses    cx,ds,si,es,di
;        cld
;        mov     cx,[coutn]
;        mov     es,[_es]
;        mov     di,[_di]
;        mov     ds,[_ds]
 ;       mov     si,[_si]
;        rep     movsb
;        ret
;endp

@end_resident:

proc    checkresident
        mov     ah,35h
        mov     al,intr
        int     21h
        mov     cx,size id
        lea     di,[id]
        lea     si,[id]
        cld
        repe    cmpsb
        ret
endp
proc    checkcmdline
        arg     sw:byte:2
        mov     ah,[sw+1]
        mov     si,80h
        xor     ch,ch
        cld
        lodsb
        mov     cl,al
next1:
        lodsb
        cmp     ah,al
        je      l1
        loop    next1
l1:
        lodsb
        and     al,11011111b
        cmp     al,[sw]
        ret
endp
proc    setup
        call    checkresident
        je      exit2
        push    ds es
        mov     ah,35h
        mov     al,intr
        int     21h
        mov     [word ptr oldv],bx
        mov     [word ptr oldv+2],es
        pop     es
        mov     dx,offset tsr
        mov     ax,cs
        mov     ds,ax
        mov     ah,25h
        mov     al,intr
        int     21h
        pop     ds
        mov     ah,09h
        mov     dx,offset mes1
        int     21h
        mov     dx,offset @end_resident
        int     27h
exit2:
        push    '/R'
        call    checkcmdline
        je      uninstall
        mov     ah,09h
        mov     dx,offset message
        int     21h
quit:
        int     20h
endp
proc    uninstall
        mov     ax,1003h
        mov     bl,false
        int     10h
        push    ds
        mov     ah,35h
        mov     al,intr
        int     21h
        mov     dx,[word ptr es:oldv+2]
        mov     ds,dx
        mov     dx,[word ptr es:oldv]
        mov     ah,25h
        mov     al,intr
        int     21h
        mov     ah,49h
        int     21h
        mov     ax,[es:2Ch]
        mov     es,ax
        mov     ah,49h
        int     21h
        mov     ah,09h
        pop     ds
        mov     dx,offset mes
        int     21h
        int     20h
endp
message db      ' Program already installed !!!',13,10,'$'
mnottsr db      ' Program not installed in memory !!!',13,10,'$'
mes     db      ' Program succesfully uninstalled !!!',13,10,'$'
mes1    db      ' All ok !',13,10,'$'
end
